<template>
  <div>
    <Toolbar :handle-submit="sendForm" :handle-reset="resetForm"></Toolbar>
    <AdminPromoCodeForm ref="createForm" :values="item" :errors="violations" />
    <Loading :visible="isLoading" />
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import AdminPromoCodeForm from "../../../components/admin/promo-code/Form";
import Loading from "../../../components/Loading";
import Toolbar from "../../../components/Toolbar";
import CreateMixin from "../../../mixins/CreateMixin";
import NotificationMixin from "../../../mixins/NotificationMixin";

const servicePrefix = "PromoCode";

export default {
  name: "PromoCodeCreate",
  servicePrefix,
  mixins: [CreateMixin, NotificationMixin],
  components: {
    Loading,
    Toolbar,
    AdminPromoCodeForm
  },
  data() {
    return {
      item: {}
    };
  },
  created() {
    if (this.userInfos) {
      this.getProfile(this.userInfos.id);
    }
  },
  watch: {
    companyFound(newData) {
      if (newData) {
        this.getStoresByCompany(this.company.id);
      }
    },
    userInfos(newData) {
      if (newData) {
        this.getCompany(newData.company["@id"].split("/")[2]);
      }
    },
    loadProfile(newData) {
      if (newData) {
        this.setLoadProfileFalse();
      }
    },
    created() {}
  },
  computed: {
    ...mapFields("user", ["userInfos", "loggedIn", "loadProfile"]),
    ...mapFields("admin", ["company", "companyFound"]),
    ...mapFields("promoCode", ["error", "isLoading", "created", "violations"])
  },
  methods: {
    ...mapActions("promoCode", ["reset"]),
    ...mapActions("adminPromoCode", ["addPromoCode"]),
    ...mapActions("admin", ["getCompany", "getStoresByCompany"]),
    ...mapActions("user", ["getProfile", "setLoadProfileFalse"]),
    sendForm() {
      this.item.company = this.userInfos.company["@id"];
      this.addPromoCode(this.item).then(() => {
        this.showMessage("Élément créé.");
        this.$router.push({ name: "PromoCodeList" });
      });
    }
  }
};
</script>
